#include"mobilemapnavimaps.h"

MobileMapNaviMaps::MobileMapNaviMaps(const QString &path = "/mnt/card/sd_map") {
	_basePath = path;
	_scale = 0;

	// ޤβ
	Radian radMapWidth = Radian(35, 0, 0, 0);
	Radian radMapHeight = Radian(30, 0, 0, 0);

	_mapW[0] = radMapWidth.toLong();
	_mapH[0] = radMapHeight.toLong();

	// Ͽޤβ
	radMapWidth = Radian(1, 0, 0, 0);
	radMapHeight = Radian(0, 40, 0, 0);
	_mapW[1] = radMapWidth.toLong();
	_mapH[1] = radMapHeight.toLong();
	for (int i = 2; i < 5; ++i) {
		_mapW[i] = _mapW[i-1] / 4;
		_mapH[i] = _mapH[i-1] / 4;
	}
	_mapW[4] = _mapW[3] / 6;
}

QString MobileMapNaviMaps::searchMapFileName(long ns, long ew,
		Radian *radMapEW, Radian *radMapNS, Radian *radMapWidth,
		Radian *radMapHeight) {
	if (_scale == 0) {
		*radMapEW = Radian(137, 30, 0, 0);
		*radMapNS = Radian(-35, 0, 0, 0);
		radMapWidth->setData(_mapW[0]);
		radMapHeight->setData(_mapH[0]);
		return _basePath + "/sharp/custom_map/map.png";
	}

	_lonid[0] = ew / _mapW[1];
	_latid[0] = ns * -1 / _mapH[1];
	long mapEW = _lonid[0] * _mapW[1];
	long mapNS = _latid[0] * _mapH[1];
	QString baseId = QString::number(_latid[0] * 100 + _lonid[0] - 100);
	QString rtnPath = _basePath + "/sharp/mdm_ds01/" + baseId;
	QString fileName = baseId;

	if (_scale >= 2) {
		_lonid[1] = (ew % _mapW[1] ) / _mapW[2];
		_latid[1] = ((-1 * ns) % _mapH[1] ) / _mapH[2];
		mapEW += _lonid[1] * _mapW[2];
		mapNS += _latid[1] * _mapH[2];
		baseId = QString::number(_latid[1] * 4 + _lonid[1], 16);
		rtnPath += "/" + baseId;
		fileName += baseId;

		if (_scale >= 3) {
			_lonid[2] = (ew % _mapW[2] ) / _mapW[3];
			_latid[2] = ((-1* ns) % _mapH[2] ) / _mapH[3];
			mapEW += _lonid[2] * _mapW[3];
			mapNS += _latid[2] * _mapH[3];
			QString baseId = QString::number(_latid[2])
					+ QString::number(_lonid[2]);
			rtnPath += "/" + baseId;
			fileName = baseId;

			if (_scale >= 4) {
				_lonid[3] = (ew % _mapW[3] ) / _mapW[4];
				_latid[3] = ((-1 * ns) % _mapH[3] ) / _mapH[4];
				mapEW += _lonid[3] * _mapW[4];
				mapNS += _latid[3] * _mapH[4];
				QString baseId = QString::number(_latid[3])
						+ QString::number(_lonid[3]);
				fileName += baseId;
			}
		}
	}

	radMapEW->setData(mapEW + _mapW[_scale] / 2);
	radMapNS->setData((mapNS + _mapH[_scale] / 2) * -1);

	radMapWidth->setData(_mapW[_scale]);
	radMapHeight->setData(_mapH[_scale]);

	return rtnPath + "/map" + fileName + ".png";
}

QString MobileMapNaviMaps::pointMapFileName(int diffLat, int diffLong,
		Radian *radMapEW, Radian *radMapNS, Radian *radMapWidth,
		Radian *radMapHeight) {
	if (_scale == 0) {
		return "";
	}
	
	int lonid[4], latid[4];

	lonid[_scale -1] = _lonid[_scale -1] + diffLong;
	latid[_scale -1] = _latid[_scale -1] - diffLat;

	for (int i = _scale -1; i > 0; --i) {
		lonid[i - 1] = _lonid[i - 1] + lonid[i] / ((i == 3) ? 6 : 4);
		latid[i - 1] = _latid[i - 1] + latid[i] / 4;
		lonid[i] = lonid[i] % ((i == 3) ? 6 : 4);
		if (lonid[i] < 0) {
			lonid[i] += ((i == 3) ? 6 : 4);
			lonid[i - 1] -= 1;
		}
		latid[i] = latid[i] % 4;
		if (latid[i] < 0) {
			latid[i] += 4;
			latid[i -1] -= 1;
		}
	}

	long mapEW = lonid[0] * _mapW[1];
	long mapNS = latid[0] * _mapH[1];
	QString baseId = QString::number(latid[0] * 100 + lonid[0] - 100);
	QString rtnPath = _basePath + "/sharp/mdm_ds01/" + baseId;
	QString fileName = baseId;

	if (_scale >= 2) {
		mapEW += lonid[1] * _mapW[2];
		mapNS += latid[1] * _mapH[2];
		baseId = QString::number(latid[1] * 4 + lonid[1], 16);
		rtnPath += "/" + baseId;
		fileName += baseId;

		if (_scale >= 3) {
			mapEW += lonid[2] * _mapW[3];
			mapNS += latid[2] * _mapH[3];
			QString baseId = QString::number(latid[2])
					+ QString::number(lonid[2]);
			rtnPath += "/" + baseId;
			fileName = baseId;

			if (_scale >= 4) {
				mapEW += lonid[3] * _mapW[4];
				mapNS += latid[3] * _mapH[4];
				QString baseId = QString::number(latid[3])
						+ QString::number(lonid[3]);
				fileName += baseId;
			}
		}
	}

	radMapEW->setData(mapEW + _mapW[_scale] / 2);
	radMapNS->setData((mapNS + _mapH[_scale] / 2) * -1);

	radMapWidth->setData(_mapW[_scale]);
	radMapHeight->setData(_mapH[_scale]);

	return rtnPath + "/map" + fileName + ".png";
}

void MobileMapNaviMaps::changeScale(const QString &scale) {
	_scale = scale.toInt();
}
